//original code from www.evilmadscientist.com/article.php/avrdac
//heavily modified by /f0 080125, again major rewrite version3 /f0 110424
//version 1.0

//could add a lot more programs - now only 3 very similar ones

//speaker left pwm - output pb1
//speaker right pwm - output pb2
//analog moni - input pc0 (delay)
//analog jon - input pc1 (max pwm count)
//analog syn - input pc2 (speed)
//digital but - input pb0 (program change)
//digital switch (only one active at a time) - input pd6, pd7

//////////////////////////////////////////////////
#include "main.h"

int main(void) {
	
	//--adc init
	ADMUX |= (1<<REFS0);							//voltage reference
	ADCSRA |= ((1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0));	//prescaler 128
	ADCSRA |= (1<<ADEN);							//enable adc
	
	//--set pull-ups for switches and pushbutton
	PORTD= _BV(PD7) | _BV(PD6);
	PORTB= _BV(PB0);
	
	//--pwm init
	DDRB= (1<<1)|(1<<2);							//activate the 2 pwm
	sei();											//enable interrupt
	
	mode= PIND&0b10000000;
	last= PINB&0b00000001;
	prg= 0;
	prg00init();									//extra make sure init
	
	//--main loop
	for (;;) {
		mode= PIND&0b10000000;						//zero if switch to the left
		if(last!=(PINB&0b00000001)) {
			last= (PINB&0b00000001);
			if(last==0) {
				prg= (prg+1)%3;
				switch(prg) {
					case 0: prg00init(); break;
					case 1: prg01init(); break;
					case 2: prg02init(); break;
				}
			}
		}
		switch(prg) {
			case 0: prg00loop(); break;
			case 1: prg01loop(); break;
			case 2: prg02loop(); break;
		}
		
	}
	return 0;
}
int analogRead(uint8_t pin) {
	uint8_t low, high;
	ADMUX = (1 << 6) | (pin & 0x07);
	ADCSRA |= (1<<ADSC);
	while (bit_is_set(ADCSRA, ADSC));
	low = ADCL;
	high = ADCH;
	return (high << 8) | low;
}
//////////////////////////////////////////////////
void prg00init() {
	TCCR1A= 242;
	TCCR1B= 25;
	m= 0;
	dir= 0;
}
void prg00loop() {
	int a= analogRead(0);	//moni
	ICR1= analogRead(1);	//jon
	int c= analogRead(2);	//syn
	n= 0;
	while(n<=(a/255)) {
		for(i= 0; i<c; i++) {}
		n++;
	}
	if(dir) {
		if(m<a) {
			m++;
		} else {
			m--;
			dir= 0;
		}
	} else {
		if(m>0) {
			m--;
		} else {
			m++;
			dir= 1;
		}
	}
	if(mode==0) {
		OCR1A= m;
		OCR1B= 0-m;
	} else {
		OCR1B= m;
		OCR1A= 0-m;
	}
}
//////////////////////////////////////////////////
void prg01init() {
	TCCR1A= 242;
	TCCR1B= 25;
	m= 0;
	dir= 0;
}
void prg01loop() {
	int a= analogRead(1);	//jon
	ICR1= analogRead(2);	//syn
	int c= analogRead(0);	//moni
	n= 0;
	while(n<=(a/255)) {
		for(i= 0; i<c; i++) {}
		n++;
	}
	if(dir) {
		if(m<a) {
			m++;
		} else {
			m--;
			dir= 0;
		}
	} else {
		if(m>0) {
			m--;
		} else {
			m++;
			dir= 1;
		}
	}
	if(mode==0) {
		OCR1A= m;
		OCR1B= 0-m;
	} else {
		OCR1B= m;
		OCR1A= 0-m;
	}
}
//////////////////////////////////////////////////
void prg02init() {
	TCCR1A= 242;
	TCCR1B= 25;
	m= 0;
	dir= 0;
}
void prg02loop() {
	int a= analogRead(2);	//syn
	ICR1= analogRead(0);	//moni
	int c= analogRead(1);	//jon
	n= 0;
	while(n<=(a/255)) {
		for(i= 0; i<c; i++) {}
		n++;
	}
	if(dir) {
		if(m<a) {
			m++;
		} else {
			m--;
			dir= 0;
		}
	} else {
		if(m>0) {
			m--;
		} else {
			m++;
			dir= 1;
		}
	}
	if(mode==0) {
		OCR1A= m;
		OCR1B= 0-m;
	} else {
		OCR1B= m;
		OCR1A= 0-m;
	}
}
